local gr	= love.graphics
local pi,sqrt,sin,cos	= math.pi,math.sqrt,math.sin,math.cos
io.stdout:setvbuf( 'no' )

function love.load()
	love.window.setTitle( 'Dashed Line' )
	an = 0
	end

function love.update( dt )
	an = an + dt
	tx = 350 * math.cos( an ) + 400
	ty = 250 * math.sin( an ) + 300
	end

function love.draw()
	p1,p2={x=tx,y=ty},{x=400,y=300}
	d,g = 8, 8
	dashLine( p1, p2, d, g )
	gr.circle('line',p1.x,p1.y,10)
	gr.circle('line',p2.x,p2.y,10)
	dashLine(p1,{x=p2.x,y=p1.y},d,g)
	dashLine({x=p2.x,y=p1.y},p2,d,g)
	dashLine(p2,{x=p1.x,y=p2.y},d,g)
	dashLine({x=p1.x,y=p2.y},p1,d,g)
	gr.setColor(255,255,255)
	gr.print( 'FPS: '..love.timer.getFPS( ), 10, 20)
	end

function love.keypressed( k )
	if k == "escape" then love.event.quit() end
	end


function dashLine( p1, p2, dash, gap )
	local dy, dx	= p2.y - p1.y, p2.x - p1.x
	local an, st	= math.atan2( dy, dx ), dash + gap
	local len		= math.sqrt( dx*dx + dy*dy )
	local nm		= ( len - dash ) / st
	gr.push()
	gr.translate( p1.x, p1.y )
	gr.rotate( an )
	for i = 0, nm do
		gr.setColor(i*255/nm,255*(nm-i)/nm,0)
		gr.line( i * st, 0, i * st + dash, 0 )
		end
	gr.line( nm * st, 0, nm * st + dash,0 )
	gr.pop()
	end
